## lizardfs 3.10.0+dfsg

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8)
set(CMAKE_LEGACY_CYGWIN_WIN32 0) # Remove when CMake >= 2.8.4 is required
set(CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR} ${CMAKE_MODULE_PATH})

if(CMAKE_SOURCE_DIR STREQUAL CMAKE_BINARY_DIR)
  message(FATAL_ERROR
    "In-source builds are disabled for this project. This is for your "
    "safety. To build the project, please create a build tree in "
    "a separate directory, for example:\n"
    "     mkdir ${CMAKE_SOURCE_DIR}/build\n"
    "     cd ${CMAKE_SOURCE_DIR}/build\n"
    "     cmake ..\n"
    "Before doing that you may need to clean up after this try by removing "
    "CMakeCache.txt file and CMakeFiles/ directory.\n"
    "If you REALLY need an in-source build, remove this check from "
    "${CMAKE_CURRENT_LIST_FILE} and try again."
  )
endif()

project(lizardfs)
set(PACKAGE_VERSION_MAJOR 3)
set(PACKAGE_VERSION_MINOR 10)
set(PACKAGE_VERSION_MICRO 0)
set(PACKAGE_VERSION
    "${PACKAGE_VERSION_MAJOR}.${PACKAGE_VERSION_MINOR}.${PACKAGE_VERSION_MICRO}")

if(NOT CMAKE_BUILD_TYPE)
  set(CMAKE_BUILD_TYPE Debug)
endif()

set(CXX_STD c++0x)
if(CYGWIN)
  set(CXX_STD gnu++11)
endif()
if(CMAKE_SYSTEM_NAME STREQUAL "SunOS")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -m64" )
  set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -m64")
endif()
if(MINGW)
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wformat=0")
endif()
string(REPLACE "-DNDEBUG" "" CMAKE_CXX_FLAGS_RELWITHDEBINFO ${CMAKE_CXX_FLAGS_RELWITHDEBINFO})
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -pipe -std=${CXX_STD} -pthread -Wall -Wextra -fwrapv")
set(CMAKE_CXX_FLAGS_DEBUG "-O0 -g")
set(CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS_RELEASE} -O3 -DNDEBUG -g")
set(CMAKE_CXX_FLAGS_RELWITHDEBINFO "${CMAKE_CXX_FLAGS_RELWITHDEBINFO} -O2 -ftree-vectorize -g -fno-omit-frame-pointer")
set(CMAKE_CXX_FLAGS_COVERAGE "-O0 -g --coverage")
set(CMAKE_CXX_FLAGS_CLANG_ANALYZE "--analyze -Xanalyzer -analyzer-output=text")
set(CMAKE_CXX_FLAGS_CLANG_SANITIZE_THREAD "-g -O0 -fsanitize=thread")

add_definitions(-D_LARGEFILE_SOURCE)
add_definitions(-D_FILE_OFFSET_BITS=64)
add_definitions(-DLIZARDFS_HAVE_CONFIG_H)
add_definitions(-D__STDC_LIMIT_MACROS)
add_definitions(-D__STDC_CONSTANT_MACROS)
add_definitions(-D__STDC_FORMAT_MACROS)
if(MINGW)
  add_definitions(-DWINVER=0x0602)
  add_definitions(-D_WIN32_WINNT=0x0602)
  add_definitions(-DFD_SETSIZE=1024)
  set(MINGW_MSVCRT "msvcr110")
endif()

# XXX(lamvak): what about OS X?
set(DEFAULT_USER  "mfs" CACHE STRING "Default user to run daemons as")
set(DEFAULT_GROUP "mfs" CACHE STRING "Default group to run daemons as")
set(LIZARDFS_BLOCKS_IN_CHUNK 1024 CACHE INT "Number of blocks in one chunk")
set(LIZARDFS_BLOCK_SIZE 65536 CACHE INT "Number of bytes in one block")
option(ENABLE_WERROR        "Enable treating compilation warnings as errors"          OFF)
option(ENABLE_LIGHTMFS      "Enable light version of LizardFS"                        OFF)
option(ENABLE_DEBIAN_PATHS  "Enable Debian-style install paths"                       OFF)
option(ENABLE_UTILS         "Enable building additional binaries used e.g. in tests"  OFF)
option(ENABLE_TESTS         "Enable building unit and functional tests"               OFF)
option(ENABLE_DOCS          "Enable building the documentation"                       ON)
option(ENABLE_EXIT_ON_USR1  "Enable handler for SIGUSR1 which calls exit()"           OFF)
option(THROW_INSTEAD_OF_ABORT   "Throw std::exception instead of calling abort"       OFF)
option(ENABLE_DEBUG_LOG     "Enable prefix based debug logs"                          OFF)
option(ENABLE_VERBOSE_ASCIIDOC  "Enable verbose output of asciidoc"                   OFF)
option(ENABLE_TCMALLOC      "Enable use of tcmalloc-minimal library"                  OFF)
option(ENABLE_POLONAISE     "Enable polonaise"                                        ON)
# end of LizardFS options
option(ENABLE_TRACES        "Enable traces"                                           OFF)
option(ENABLE_CRC           "Enable checksums"                                        ON)
option(ENABLE_REQUEST_LOG   "Enable logging request times"                            OFF)
option(USE_LEGACY_READ_MESSAGES "Enable sending old type of messages by mount"        OFF)

message(STATUS "CMAKE_BUILD_TYPE: ${CMAKE_BUILD_TYPE}")
message(STATUS "CMAKE_INSTALL_PREFIX: ${CMAKE_INSTALL_PREFIX}")
message(STATUS "DEFAULT_USER: ${DEFAULT_USER}")
message(STATUS "DEFAULT_GROUP: ${DEFAULT_GROUP}")
message(STATUS "LIZARDFS_BLOCKS_IN_CHUNK: ${LIZARDFS_BLOCKS_IN_CHUNK}")
message(STATUS "LIZARDFS_BLOCK_SIZE: ${LIZARDFS_BLOCK_SIZE}")
message(STATUS "ENABLE_WERROR: ${ENABLE_WERROR}")
message(STATUS "ENABLE_LIGHTMFS: ${ENABLE_LIGHTMFS}")
message(STATUS "ENABLE_DEBIAN_PATHS: ${ENABLE_DEBIAN_PATHS}")
message(STATUS "ENABLE_UTILS: ${ENABLE_UTILS}")
message(STATUS "ENABLE_TESTS: ${ENABLE_TESTS}")
message(STATUS "ENABLE_DOCS: ${ENABLE_DOCS}")
message(STATUS "ENABLE_EXIT_ON_USR1: ${ENABLE_EXIT_ON_USR1}")
message(STATUS "THROW_INSTEAD_OF_ABORT: ${THROW_INSTEAD_OF_ABORT}")
message(STATUS "ENABLE_DEBUG_LOG: ${ENABLE_DEBUG_LOG}")
message(STATUS "ENABLE_VERBOSE_ASCIIDOC: ${ENABLE_VERBOSE_ASCIIDOC}")
message(STATUS "ENABLE_TCMALLOC: ${ENABLE_TCMALLOC}")
message(STATUS "ENABLE_POLONAISE: ${ENABLE_POLONAISE}")
# end of LizardFS options values
message(STATUS "ENABLE_TRACES: ${ENABLE_TRACES}")
message(STATUS "ENABLE_CRC: ${ENABLE_CRC}")
message(STATUS "ENABLE_REQUEST_LOG: ${ENABLE_REQUEST_LOG}")
message(STATUS "USE_LEGACY_READ_MESSAGES: ${USE_LEGACY_READ_MESSAGES}")

# All the environment tests (libs, includes, etc.) live here:
include(EnvTests.cmake)
include(Libraries)
include(GNUInstallDirs)
check_includes("${INCLUDES}")

# Disable -pedantic for old gcc because of unfounded
# "no comma at end of enumerator list" warning during crcutil compilation
execute_process(COMMAND ${CMAKE_CXX_COMPILER} -dumpversion OUTPUT_VARIABLE COMPILER_VERSION)
if(ENABLE_WERROR AND CMAKE_CXX_COMPILER_ID STREQUAL "GNU" AND COMPILER_VERSION VERSION_LESS 4.7)
  message(STATUS "Flag '-pedantic' disabled for GCC < 4.7")
else()
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -pedantic")
endif()

if ("${CMAKE_CXX_COMPILER_ID}" STREQUAL "Clang")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Qunused-arguments")
endif()

if(CXX_HAS_WNOGNU)
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-gnu")
endif()

if(ENABLE_WERROR)
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Werror")
endif()

if(ENABLE_TESTS AND NOT THROW_INSTEAD_OF_ABORT)
  message(STATUS "Tests require THROW_INSTEAD_OF_ABORT to be set to YES, changing passed value:")
  set(THROW_INSTEAD_OF_ABORT YES)
  message(STATUS "THROW_INSTEAD_OF_ABORT: ${THROW_INSTEAD_OF_ABORT}")
endif()

if(ENABLE_DEBIAN_PATHS)
  if (NOT CMAKE_INSTALL_PREFIX STREQUAL "/")
    message(WARNING "Debian paths enabled, but CMAKE_INSTALL_PREFIX is different than /")
  endif()
  set(BIN_SUBDIR   "usr/bin")
  set(SBIN_SUBDIR  "usr/sbin")
  set(LIB_SUBDIR   "usr/lib")
  set(ETC_SUBDIR   "etc/mfs")
  set(RUN_SUBDIR   "var/run/mfs")
  set(DATA_SUBDIR  "var/lib/mfs")
  set(MAN_SUBDIR   "usr/share/man")
  set(CGI_SUBDIR   "usr/share/mfscgi")
else()
  set(BIN_SUBDIR   "bin")
  set(SBIN_SUBDIR  "sbin")
  set(LIB_SUBDIR   "lib")
  set(ETC_SUBDIR   "etc/mfs")
  set(RUN_SUBDIR   "var/run/mfs")
  set(DATA_SUBDIR  "var/lib/mfs")
  set(MAN_SUBDIR   "share/man")
  set(CGI_SUBDIR   "share/mfscgi")
endif()

string(REGEX REPLACE "/$" "" INSTALL_PREFIX_NO_SLASH ${CMAKE_INSTALL_PREFIX})
set(BIN_PATH   ${INSTALL_PREFIX_NO_SLASH}/${BIN_SUBDIR})
set(SBIN_PATH  ${INSTALL_PREFIX_NO_SLASH}/${SBIN_SUBDIR})
set(LIB_PATH   ${INSTALL_PREFIX_NO_SLASH}/${LIB_SUBDIR})
set(ETC_PATH   ${INSTALL_PREFIX_NO_SLASH}/${ETC_SUBDIR})
set(RUN_PATH   ${INSTALL_PREFIX_NO_SLASH}/${RUN_SUBDIR})
set(DATA_PATH  ${INSTALL_PREFIX_NO_SLASH}/${DATA_SUBDIR})
set(MAN_PATH   ${INSTALL_PREFIX_NO_SLASH}/${MAN_SUBDIR})
set(CGI_PATH   ${INSTALL_PREFIX_NO_SLASH}/${CGI_SUBDIR})

if(ENABLE_LIGHTMFS)
  set(PROTO_BASE 65536)
  set(LIGHT_MFS 1)
else()
  set(PROTO_BASE 0)
  set(LIGHT_MFS 0)
endif()

if(ENABLE_UTILS)
  set(BUILD_UTILS ON)
endif()

if(ENABLE_TESTS)
  set(BUILD_TESTS ON)
  set(BUILD_UTILS ON)
  set(LIZARDFS_ENABLE_DEBUG_LOG ON)
endif()

if(ENABLE_DEBUG_LOG)
  set(LIZARDFS_ENABLE_DEBUG_LOG ON)
endif()

if(ENABLE_TRACES)
  if(NOT Boost_INCLUDE_DIRS)
    message(FATAL_ERROR "Boost headers are required if traces are enabled")
  endif()
  add_definitions(-DENABLE_TRACES)
endif()

if(ENABLE_REQUEST_LOG)
  if(NOT Boost_IOSTREAMS_FOUND)
    message(FATAL_ERROR "Boost iostreams is required if request time logging is enabled")
  endif()
  set(ADDITIONAL_LIBS ${Boost_IOSTREAMS_LIBRARY})
  add_definitions(-DENABLE_REQUEST_LOG)
endif()

set(CHARTS_CSV_CHARTID_BASE 90000)

if(THROW_INSTEAD_OF_ABORT)
  add_definitions(-DTHROW_INSTEAD_OF_ABORT)
endif()

if(USE_LEGACY_READ_MESSAGES)
  add_definitions(-DUSE_LEGACY_READ_MESSAGES)
endif()

if(ENABLE_CRC)
  message(STATUS "CRC checksums enabled")
  add_definitions(-DENABLE_CRC)
else()
  message(STATUS "CRC checksums disabled")
endif()

set(CHARTS_CSV_CHARTID_BASE 90000)

# Create config.h file
configure_file(config.h.in config.h)
include_directories(${CMAKE_BINARY_DIR}) # Here we have generated config.h

# main.cc shared by some LizardFS applications
set(MAIN_SRC ${CMAKE_SOURCE_DIR}/src/main/main.cc)

# functions & macros
macro(collect_sources VAR_PREFIX)
  file(GLOB ${VAR_PREFIX}_TESTS *_unittest.cc)
  file(GLOB ${VAR_PREFIX}_SOURCES *.cc *.h)
  file(GLOB ${VAR_PREFIX}_MAIN main.cc)
  if(${VAR_PREFIX}_MAIN OR ${VAR_PREFIX}_TESTS)
    list(REMOVE_ITEM ${VAR_PREFIX}_SOURCES ${${VAR_PREFIX}_TESTS} ${${VAR_PREFIX}_MAIN})
  endif()
endmacro(collect_sources)

function(add_tests TESTED_LIBRARY)
  if(NOT BUILD_TESTS OR ARGC EQUAL 1)
    return()
  endif()
  list(REMOVE_AT ARGV 0)
  set(TEST_LIBRARY_NAME ${TESTED_LIBRARY}_tests)
  include_directories(${GTEST_INCLUDE_DIRS})
  add_library(${TEST_LIBRARY_NAME} ${ARGV})
  target_link_libraries(${TEST_LIBRARY_NAME} ${TESTED_LIBRARY})
  set(TMP ${TEST_LIBRARIES})
  list(APPEND TMP ${TEST_LIBRARY_NAME})
  set(TEST_LIBRARIES ${TMP} CACHE INTERNAL "" FORCE)
endfunction(add_tests)

if(ZLIB_FOUND)
  include_directories(${ZLIB_INCLUDE_DIRS})
endif()
include_directories(src) # Allow paths relative to src, eg. #include common/crc.h
link_directories( ${LINK_DIRECTORIES} ${FUSE_LIBRARY_DIR} )
add_subdirectory(external)
add_subdirectory(src/admin)
add_subdirectory(src/common)
add_subdirectory(src/protocol)
add_subdirectory(src/mount)

if(ENABLE_POLONAISE)
  add_subdirectory(src/mount/polonaise)
endif()

if(NOT MINGW)
  if(BUILD_DEVTOOLS)
    add_subdirectory(src/devtools)
  endif()
  add_subdirectory(src/chunkserver)
  add_subdirectory(src/master)
  add_subdirectory(src/metadump)
  add_subdirectory(src/metalogger)
  add_subdirectory(src/metarestore)
  add_subdirectory(src/tools)
  if (FUSE_LIBRARY)
    add_subdirectory(src/mount/fuse)
  endif()
  add_subdirectory(src/data)
  add_subdirectory(src/cgi)
  if(BUILD_UTILS)
    add_subdirectory(utils)
  endif()
  if(BUILD_TESTS)
    add_subdirectory(src/unittests)
    add_subdirectory(tests)
  endif()
  if(ENABLE_DOCS)
    add_subdirectory(doc)
  endif()
endif()

=== doc/CMakeLists.txt ===
if(NOT A2X_BINARY)
  message(WARNING "Program 'a2x' not found, manpages won't be generated")
  return()
endif()

# These manpages should be generated
set(MANPAGES
    lizardfs.7          # not a source
    lizardfs-admin.8
    lizardfs-cgiserver.8
    lizardfs-probe.8    # not a source
    mfsappendchunks.1
    mfscheckfile.1
    mfsdirinfo.1
    mfsfileinfo.1
    mfsfilerepair.1
    mfsgeteattr.1
    mfsseteattr.1       # not a source
    mfsdeleattr.1       # not a source
    mfsgetgoal.1
    mfssetgoal.1        # not a source
    mfsrgetgoal.1       # not a source
    mfsrsetgoal.1       # not a source
    mfsgettrashtime.1
    mfssettrashtime.1   # not a source
    mfsrgettrashtime.1  # not a source
    mfsrsettrashtime.1  # not a source
    mfsmakesnapshot.1
    mfsmount.1
    mfsrepquota.1
    mfssetquota.1       # not a source
    mfstools.1
    globaliolimits.cfg.5
    iolimits.cfg.5
    mfschunkserver.cfg.5
    mfsexports.cfg.5
    mfsgoals.cfg.5
    mfshdd.cfg.5
    mfsmaster.cfg.5
    mfsmetalogger.cfg.5
    mfstopology.cfg.5
    mfsmetadump.8
    mfsrestoremaster.8
    moosefs.7
    mfs.7               # not a source
    mfscgiserv.8
    mfschunkserver.8
    mfsmaster.8
    mfsmetalogger.8
    mfsmetarestore.8
)

set(INSTALLED_MANPAGES)
foreach(MANPAGE ${MANPAGES})
  get_filename_component(MANPAGE_SRC ${CMAKE_CURRENT_SOURCE_DIR}/${MANPAGE}.txt ABSOLUTE)
  string(REGEX MATCH "[0-9]$" SECTION_NUMBER ${MANPAGE})
  set(GENERATED_MANPAGE_PATH ${CMAKE_CURRENT_BINARY_DIR}/${MANPAGE})
  if(ENABLE_VERBOSE_ASCIIDOC)
    set(ASCIIDOC_VERBOSE --verbose --keep-artifacts)
  else()
    set(ASCIIDOC_VERBOSE)
  endif()
  if(EXISTS ${MANPAGE_SRC})
    # Generate from the source...
    set(MANPAGE_SRC_SYMLINK ${CMAKE_CURRENT_BINARY_DIR}/${MANPAGE}.txt)
    add_custom_command(OUTPUT ${GENERATED_MANPAGE_PATH}
        COMMAND ln -s -f ${MANPAGE_SRC} ${MANPAGE_SRC_SYMLINK}
        COMMAND a2x ${ASCIIDOC_VERBOSE} -L -f manpage ${MANPAGE_SRC_SYMLINK}
        DEPENDS ${MANPAGE_SRC})
    # Add this file to the main target's dependencies
    set(GENERATED_MANPAGES ${GENERATED_MANPAGES} ${GENERATED_MANPAGE_PATH})
  endif()
  # Install the generated file
  install(FILES ${GENERATED_MANPAGE_PATH} DESTINATION ${MAN_SUBDIR}/man${SECTION_NUMBER})
endforeach()
add_custom_target(manpages ALL SOURCES ${GENERATED_MANPAGES})

=== src/common/CMakeLists.txt ===
include_directories(${CMAKE_CURRENT_SOURCE_DIR})

collect_sources(COMMON)

if(MINGW)
list(REMOVE_ITEM COMMON_SOURCES "${CMAKE_CURRENT_SOURCE_DIR}/lockfile.cc")
list(REMOVE_ITEM COMMON_SOURCES "${CMAKE_CURRENT_SOURCE_DIR}/metadata.cc")
list(REMOVE_ITEM COMMON_SOURCES "${CMAKE_CURRENT_SOURCE_DIR}/setup.cc")
endif()

if(ISAL_LIBRARY)
  list(REMOVE_ITEM COMMON_SOURCES "${CMAKE_CURRENT_SOURCE_DIR}/galois_field_isal.cc")
  list(REMOVE_ITEM COMMON_SOURCES "${CMAKE_CURRENT_SOURCE_DIR}/galois_field_encode.cc")
endif()

add_library(mfscommon ${COMMON_SOURCES})
if (HAVE_CRCUTIL)
  # Use crcutil Library
  include_directories(${CRCUTIL_INCLUDE_DIRS})
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${CRCUTIL_CXX_FLAGS}")
  target_link_libraries(mfscommon ${CRCUTIL_LIBRARIES})
endif()
if (ZLIB_FOUND)
  target_link_libraries(mfscommon ${ZLIB_LIBRARIES})
endif()
if (RT_LIBRARY)
  target_link_libraries(mfscommon ${RT_LIBRARY})
endif()
if(TCMALLOC_LIBRARY)
  target_link_libraries(mfscommon ${TCMALLOC_LIBRARY})
endif()
if(SOCKET_FOUND)
  target_link_libraries(mfscommon ${SOCKET_LIBRARIES})
endif()
if(MINGW)
  target_link_libraries(mfscommon ${MINGW_MSVCRT})
endif()
if(ISAL_LIBRARY)
  target_link_libraries(mfscommon ${ISAL_LIBRARY})
endif()

add_tests(mfscommon ${COMMON_TESTS})

=== src/metarestore/CMakeLists.txt ===
include_directories(${CMAKE_CURRENT_SOURCE_DIR} ../master)
add_definitions(-DMETARESTORE)
add_definitions(-DAPPNAME=mfsmetarestore)

collect_sources(METARESTORE)

file(GLOB METARESTORE_MASTER_SOURCES ../master/filesystem*.cc)

if(DB_FOUND)
  file(GLOB METARESTORE_HSTRING_SOURCES ../master/hstring_*storage.cc)
else()
  file(GLOB METARESTORE_HSTRING_SOURCES ../master/hstring_memstorage.cc)
endif()

add_library(metarestore ${METARESTORE_SOURCES} ${METARESTORE_MASTER_SOURCES} ${METARESTORE_HSTRING_SOURCES}
  ../master/chunks.cc ../master/quota_database.cc ../master/chunk_goal_counters.cc ../master/restore.cc ../master/locks.cc)

target_link_libraries(metarestore mfscommon)
if(JUDY_LIBRARY)
  target_link_libraries(metarestore ${JUDY_LIBRARY})
endif()
add_tests(metarestore ${METARESTORE_TESTS})

add_executable(mfsmetarestore ${METARESTORE_MAIN})
target_link_libraries(mfsmetarestore metarestore mfscommon ${PAM_LIBRARIES})
install(TARGETS mfsmetarestore RUNTIME DESTINATION ${SBIN_SUBDIR})

=== src/unittests/CMakeLists.txt ===
include_directories(${GTEST_INCLUDE_DIRS})

add_subdirectory(mocks)

collect_sources(UNITTESTS)
add_library(unittests-helpers ${UNITTESTS_SOURCES})
add_tests(unittests-helpers ${UNITTESTS_TESTS})

add_executable(unittests ${UNITTESTS_MAIN})
if(APPLE)
    set(OSX_TEST_LIBRARIES "")
    foreach(f ${TEST_LIBRARIES})
        list(APPEND OSX_TEST_LIBRARIES "-Wl,-force_load" "${f}")
    endforeach(f)
    target_link_libraries(unittests gtest mfscommon master ${OSX_TEST_LIBRARIES}
        unittests-helpers unittest-mocks ${Boost_SYSTEM_LIBRARY} ${Boost_FILESYSTEM_LIBRARY})
else()
    target_link_libraries(unittests gtest mfscommon master
        "-Wl,--whole-archive" ${TEST_LIBRARIES} "-Wl,--no-whole-archive"
        unittests-helpers unittest-mocks ${Boost_SYSTEM_LIBRARY} ${Boost_FILESYSTEM_LIBRARY})
endif()

=== debian/changelog ===
lizardfs (3.10.0+dfsg-1) unstable; urgency=low

  * New upstream release [August 2016].
  * Upload to unstable.

 -- Dmitry Smirnov <onlyjob@debian.org>  Sat, 06 Aug 2016 14:59:15 +1000

lizardfs (3.10.0~rc+git20160714.0.4d361b9-1) experimental; urgency=medium

  * New upstream snapshot.
  * Removed obsolete patches:
    - delay-check-loop.patch
    - fix-FTBFS-kfreebsd.patch

 -- Dmitry Smirnov <onlyjob@debian.org>  Thu, 14 Jul 2016 22:29:18 +1000

lizardfs (3.10.0~rc+git20160711.0.5c68866-1) experimental; urgency=low

  * New upstream pre-release snapshot [July 2016].
  * Build-Depends += "libisal-dev [amd64 kfreebsd-amd64]".
  * dbgsym-migration: dropped -dbg package; debhelper (>= 9.20160403).
  * chunkserver.service:
    + After += "local-fs.target" to start after local mounts are ready.
    + less aggressive IO by using IO accounting.
  * New patch to delay check loop.

 -- Dmitry Smirnov <onlyjob@debian.org>  Tue, 12 Jul 2016 07:38:53 +1000

lizardfs (3.9.4+dfsg-7) unstable; urgency=medium

  * FTBFS patches (Closes: #822505).

 -- Dmitry Smirnov <onlyjob@debian.org>  Thu, 05 May 2016 15:57:46 +1000

lizardfs (3.9.4+dfsg-6) unstable; urgency=medium

  * Link with "-latomic" on sh4.
  * New upstream patch to fix trash emptying conditions.

 -- Dmitry Smirnov <onlyjob@debian.org>  Sat, 02 Apr 2016 11:46:32 +1100

lizardfs (3.9.4+dfsg-5) unstable; urgency=medium

  * Link with "-latomic" on m68k.
  * patch: remove SPLICE entirely.
  * patch: SPARSE chunk files (enabled by default).
  * Standards-Version: 3.9.7

 -- Dmitry Smirnov <onlyjob@debian.org>  Sun, 13 Mar 2016 19:28:41 +1100

=== debian/control ===
Source: lizardfs
Section: admin
Priority: optional
Maintainer: Dmitry Smirnov <onlyjob@debian.org>
Build-Depends: debhelper (>= 9.20160403~), dh-python, dh-systemd
              ,python-all
              ,cmake
              ,asciidoc
                  ,libxml2-utils
                  ,docbook-xml
                  ,docbook-xsl
                  ,xsltproc
              ,pkg-config
# libcrcutil is for little-endian architectures only.
              ,libcrcutil-dev [!hppa !m68k !mips !powerpc !powerpcspe !ppc64 !s390 !s390x !sparc !sparc64]
              ,libfuse-dev (>= 2.9.0)
#_beware:     ,libgoogle-perftools-dev
              ,libgtest-dev
              ,libisal-dev [amd64 kfreebsd-amd64]
              ,libjudy-dev
              ,libpam-dev
              ,libsystemd-dev [!kfreebsd-any]
#             ,libthrift-dev
              ,zlib1g-dev
# -DENABLE_TESTS=YES requirements:
             ,libboost-all-dev [amd64]
Standards-Version: 3.9.8
X-Python-Version: >= 2.7 << 3.0
Homepage: http://lizardfs.org/
Vcs-Browser: https://anonscm.debian.org/cgit/collab-maint/lizardfs.git
Vcs-Git: https://anonscm.debian.org/git/collab-maint/lizardfs.git

Package: lizardfs-common
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
        ,adduser
Description: LizardFS - common files
 Files and services common for all LizardFS daemons.
 .
 LizardFS is a reliable, scalable and efficient distributed file system. It
 spreads data over a number of physical servers, making it visible to an
 end user as a single file system.
 .
 Functions such as data replication, checksums, instant snapshots and easy
 connection of additional servers make LizardFS a perfect solution for
 users who need fault-proof storage ready for future expansion.
 LizardFS features include:
  * High availbility.
  * Quotas.
  * POSIX Access Control Lists and POSIX Extended Attributes.
  * I/O bandwidth limiting.
 .
 LizardFS can be used whenever one needs to store large quantities of data
 in a secure way and process them swiftly.
 LizardFS is a fork of MooseFS.

Package: lizardfs-master
Built-Using: ${my:Built-Using}
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
        ,lizardfs-common (>= ${source:Version})
Description: LizardFS - master server
 LizardFS master (metadata) server.
 .
 LizardFS is a reliable, scalable and efficient distributed file system. It
 spreads data over a number of physical servers, making it visible to an
 end user as a single file system.
 .
 Functions such as data replication, checksums, instant snapshots and easy
 connection of additional servers make LizardFS a perfect solution for
 users who need fault-proof storage ready for future expansion.
 LizardFS features include:
  * High availbility.
  * Quotas.
  * POSIX Access Control Lists and POSIX Extended Attributes.
  * I/O bandwidth limiting.
 .
 LizardFS can be used whenever one needs to store large quantities of data
 in a secure way and process them swiftly.
 LizardFS is a fork of MooseFS.

Package: lizardfs-metalogger
Built-Using: ${my:Built-Using}
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
        ,lizardfs-common (>= ${source:Version})
Description: LizardFS - metalogger server
 LizardFS metadata replication (backup) server.
 .
 LizardFS is a reliable, scalable and efficient distributed file system. It
 spreads data over a number of physical servers, making it visible to an
 end user as a single file system.
 .
 Functions such as data replication, checksums, instant snapshots and easy
 connection of additional servers make LizardFS a perfect solution for
 users who need fault-proof storage ready for future expansion.
 LizardFS features include:
  * High availbility.
  * Quotas.
  * POSIX Access Control Lists and POSIX Extended Attributes.
  * I/O bandwidth limiting.
 .
 LizardFS can be used whenever one needs to store large quantities of data
 in a secure way and process them swiftly.
 LizardFS is a fork of MooseFS.

Package: lizardfs-chunkserver
Built-Using: ${my:Built-Using}
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
        ,lizardfs-common (>= ${source:Version})
Description: LizardFS - data server
 The LizardFS data server.
 .
 LizardFS is a reliable, scalable and efficient distributed file system. It
 spreads data over a number of physical servers, making it visible to an
 end user as a single file system.
 .
 Functions such as data replication, checksums, instant snapshots and easy
 connection of additional servers make LizardFS a perfect solution for
 users who need fault-proof storage ready for future expansion.
 LizardFS features include:
  * High availbility.
  * Quotas.
  * POSIX Access Control Lists and POSIX Extended Attributes.
  * I/O bandwidth limiting.
 .
 LizardFS can be used whenever one needs to store large quantities of data
 in a secure way and process them swiftly.
 LizardFS is a fork of MooseFS.

Package: lizardfs-client
Built-Using: ${my:Built-Using}
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: LizardFS - client tools and mount utility
 LizardFS FUSE mount utility "mfsmount" and client tool "mfstools".
 .
 LizardFS is a reliable, scalable and efficient distributed file system. It
 spreads data over a number of physical servers, making it visible to an
 end user as a single file system.
 .
 Functions such as data replication, checksums, instant snapshots and easy
 connection of additional servers make LizardFS a perfect solution for
 users who need fault-proof storage ready for future expansion.
 LizardFS features include:
  * High availbility.
  * Quotas.
  * POSIX Access Control Lists and POSIX Extended Attributes.
  * I/O bandwidth limiting.
 .
 LizardFS can be used whenever one needs to store large quantities of data
 in a secure way and process them swiftly.
 LizardFS is a fork of MooseFS.

Package: lizardfs-adm
Built-Using: ${my:Built-Using}
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: LizardFS - administration tools
 LizardFS administration tool: lizardfs-probe
 .
 LizardFS is a reliable, scalable and efficient distributed file system. It
 spreads data over a number of physical servers, making it visible to an
 end user as a single file system.
 .
 Functions such as data replication, checksums, instant snapshots and easy
 connection of additional servers make LizardFS a perfect solution for
 users who need fault-proof storage ready for future expansion.
 LizardFS features include:
  * High availbility.
  * Quotas.
  * POSIX Access Control Lists and POSIX Extended Attributes.
  * I/O bandwidth limiting.
 .
 LizardFS can be used whenever one needs to store large quantities of data
 in a secure way and process them swiftly.
 LizardFS is a fork of MooseFS.

Package: lizardfs-cgi
Architecture: all
Depends: ${misc:Depends}, ${python:Depends}
        ,python
Description: LizardFS - CGI monitor
 CGI application to monitor LizardFS through master/metadata server.
 .
 LizardFS is a reliable, scalable and efficient distributed file system. It
 spreads data over a number of physical servers, making it visible to an
 end user as a single file system.
 .
 Functions such as data replication, checksums, instant snapshots and easy
 connection of additional servers make LizardFS a perfect solution for
 users who need fault-proof storage ready for future expansion.
 LizardFS features include:
  * High availbility.
  * Quotas.
  * POSIX Access Control Lists and POSIX Extended Attributes.
  * I/O bandwidth limiting.
 .
 LizardFS can be used whenever one needs to store large quantities of data
 in a secure way and process them swiftly.
 LizardFS is a fork of MooseFS.

Package: lizardfs-cgiserv
Built-Using: ${my:Built-Using}
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
        ,lizardfs-cgi
        ,lizardfs-common (>= ${source:Version})
        ,${python:Depends}
Description: simple CGI-capable HTTP server to run LizardFS CGI monitor
 Simple standalone CGI-capable HTTP server to run LizardFS CGI Monitor.
 .
 LizardFS is a reliable, scalable and efficient distributed file system. It
 spreads data over a number of physical servers, making it visible to an
 end user as a single file system.
 .
 Functions such as data replication, checksums, instant snapshots and easy
 connection of additional servers make LizardFS a perfect solution for
 users who need fault-proof storage ready for future expansion.
 LizardFS features include:
  * High availbility.
  * Quotas.
  * POSIX Access Control Lists and POSIX Extended Attributes.
  * I/O bandwidth limiting.
 .
 LizardFS can be used whenever one needs to store large quantities of data
 in a secure way and process them swiftly.
 LizardFS is a fork of MooseFS.

#Package: lizardfs-tests
#Built-Using: ${my:Built-Using}
#Architecture: any
#Depends: ${shlibs:Depends}, ${misc:Depends}
#        ,lizardfs-common (>= ${source:Version})
#        ,lizardfs-chunkserver (>= ${source:Version})
#        ,lizardfs-master (>= ${source:Version})
#        ,lizardfs-client (>= ${source:Version})
#        ,lizardfs-adm (>= ${source:Version})
#        ,attr
#        ,dbench
#        ,fuse
#        ,netcat-openbsd
#        ,socat
#        ,sudo
#        ,valgrind
#Description: LizardFS - tests suite
# The LizardFS test suite.
# .
# LizardFS is a reliable, scalable and efficient distributed file system. It
# spreads data over a number of physical servers, making it visible to an
# end user as a single file system.
# .
# Functions such as data replication, checksums, instant snapshots and easy
# connection of additional servers make LizardFS a perfect solution for
# users who need fault-proof storage ready for future expansion.
# LizardFS features include:
#  * High availbility.
#  * Quotas.
#  * POSIX Access Control Lists and POSIX Extended Attributes.
#  * I/O bandwidth limiting.
# .
# LizardFS can be used whenever one needs to store large quantities of data
# in a secure way and process them swiftly.
# LizardFS is a fork of MooseFS.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

## fix FTBFS@ppc64: https://github.com/lizardfs/lizardfs/issues/249
ifneq (,$(filter $(DEB_HOST_ARCH),mips mipsel powerpc powerpcspe sparc hppa m68k sh4))
DEB_LDFLAGS_MAINT_APPEND = -latomic
endif

# minimise needless linking
export DEB_LDFLAGS_MAINT_APPEND += -Wl,--as-needed

## Build tests only on amd64, see https://github.com/lizardfs/lizardfs/issues/197
ifeq ($(DEB_HOST_ARCH),amd64)
OPTARGS = -DENABLE_TESTS=YES
endif

%:
	dh $@ --buildsystem=cmake --builddirectory=build --parallel --with systemd,python2

override_dh_auto_clean:
	$(RM) -rv external/gtest
	dh_auto_clean

override_dh_auto_configure:
	## copy gtest sources
	cp -Rv /usr/src/gtest external/
	dh_auto_configure -- $(OPTARGS)    \
               -DCMAKE_BUILD_TYPE=Release   \
               -DCMAKE_INSTALL_PREFIX="/"   \
               -DCMAKE_VERBOSE_MAKEFILE=ON  \
               -DENABLE_VERBOSE_ASCIIDOC=ON \
               -DENABLE_DEBIAN_PATHS=YES    \
               -DENABLE_TCMALLOC=NO         \
               -DENABLE_UTILS=YES

override_dh_auto_install:
	dh_auto_install
	## rename config files
	for i in debian/tmp/etc/lizardfs/*.cfg.dist; do \
	    mv -n -v "$$i" "$${i%%.dist}"          \
	;done

override_dh_python2:
	dh_python2
	dh_python2 /usr/share/mfscgi

override_dh_gencontrol:
	dh_gencontrol -- -Vmy:Built-Using="$(foreach pkg,libgtest-dev,$(word 2,$(shell dpkg --status $(pkg) | grep Source)) (=$(word 2,$(shell dpkg --status $(pkg) | grep Version))),)"

override_dh_compress:
	## See #781131
	dh_compress --exclude="examples/mfsexports.cfg" --exclude="examples/mfsmaster.cfg"

override_dh_installchangelogs:
	dh_installchangelogs NEWS

override_dh_installinit:
	dh_installinit --no-start

override_dh_systemd_start:
	dh_systemd_start --no-start

override_dh_systemd_enable:
	dh_systemd_enable --no-enable

override_dh_strip:
	dh_strip --dbgsym-migration='lizardfs-dbg (<< 3.10.0~)'

## http://wiki.debian.org/onlyjob/get-orig-source
.PHONY: get-orig-source
PKD   = $(abspath $(dir $(MAKEFILE_LIST)))
PKG   = $(word 2,$(shell dpkg-parsechangelog -l$(PKD)/changelog | grep ^Source))
VER  ?= $(shell dpkg-parsechangelog -l$(PKD)/changelog -SVersion | perl -ne 'print $$1 if m{^(?:\d+:)?(\d.*)(?:\-\d+.*)};')
REV   = $(shell sh -c 'printf "$${1\#\#*\.0\.}"' -- "$(VER)")

get-orig-source: $(PKG)_$(VER).orig.tar.xz $(info I: $(PKG)_$(VER))
	@

UURL = https://github.com/lizardfs/lizardfs
$(PKG)_$(VER).orig.tar.xz:
	$(if $(wildcard $(PKG)-$(VER)),$(error $(PKG)-$(VER) exist, aborting..))
	@echo "# Downloading..."
	wget --tries=3 --timeout=40 --read-timeout=40 --continue -O $@ \
          $(UURL)/archive/$(REV).tar.gz \
        || uscan --noconf --verbose --rename --destdir=$(CURDIR) --check-dirname-level=0 --force-download --download-current-version $(PKD)
	mk-origtargz --repack --repack-suffix "" --compression xz --directory . $@

## lizardfs 3.10.4+dfsg

=== CMakeLists.txt ===
--- 
+++ 
@@ -20,7 +20,7 @@
 project(lizardfs)
 set(PACKAGE_VERSION_MAJOR 3)
 set(PACKAGE_VERSION_MINOR 10)
-set(PACKAGE_VERSION_MICRO 0)
+set(PACKAGE_VERSION_MICRO 4)
 set(PACKAGE_VERSION
     "${PACKAGE_VERSION_MAJOR}.${PACKAGE_VERSION_MINOR}.${PACKAGE_VERSION_MICRO}")
 
@@ -29,8 +29,8 @@
 endif()
 
 set(CXX_STD c++0x)
-if(CYGWIN)
-  set(CXX_STD gnu++11)
+if(CMAKE_CXX_COMPILER_ID MATCHES ".*Clang.*")
+  set(CXX_STD c++11)
 endif()
 if(CMAKE_SYSTEM_NAME STREQUAL "SunOS")
   set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -m64" )
@@ -47,6 +47,8 @@
 set(CMAKE_CXX_FLAGS_COVERAGE "-O0 -g --coverage")
 set(CMAKE_CXX_FLAGS_CLANG_ANALYZE "--analyze -Xanalyzer -analyzer-output=text")
 set(CMAKE_CXX_FLAGS_CLANG_SANITIZE_THREAD "-g -O0 -fsanitize=thread")
+
+set(CMAKE_CXX_FLAGS_CXXDEBUG "-O0 -g -D_GLIBCXX_DEBUG")
 
 add_definitions(-D_LARGEFILE_SOURCE)
 add_definitions(-D_FILE_OFFSET_BITS=64)
@@ -213,6 +215,10 @@
 
 set(CHARTS_CSV_CHARTID_BASE 90000)
 
+if(CMAKE_SYSTEM_NAME STREQUAL "FreeBSD")
+  include_directories("/usr/local/include")
+endif()
+
 if(THROW_INSTEAD_OF_ABORT)
   add_definitions(-DTHROW_INSTEAD_OF_ABORT)
 endif()

=== doc/CMakeLists.txt ===
--- 
+++ 
@@ -9,27 +9,27 @@
     lizardfs-admin.8
     lizardfs-cgiserver.8
     lizardfs-probe.8    # not a source
-    mfsappendchunks.1
-    mfscheckfile.1
-    mfsdirinfo.1
-    mfsfileinfo.1
-    mfsfilerepair.1
-    mfsgeteattr.1
-    mfsseteattr.1       # not a source
-    mfsdeleattr.1       # not a source
-    mfsgetgoal.1
-    mfssetgoal.1        # not a source
-    mfsrgetgoal.1       # not a source
-    mfsrsetgoal.1       # not a source
-    mfsgettrashtime.1
-    mfssettrashtime.1   # not a source
-    mfsrgettrashtime.1  # not a source
-    mfsrsettrashtime.1  # not a source
-    mfsmakesnapshot.1
+    lizardfs-appendchunks.1
+    lizardfs-checkfile.1
+    lizardfs-dirinfo.1
+    lizardfs-fileinfo.1
+    lizardfs-filerepair.1
+    lizardfs-geteattr.1
+    lizardfs-seteattr.1       # not a source
+    lizardfs-deleattr.1       # not a source
+    lizardfs-getgoal.1
+    lizardfs-setgoal.1        # not a source
+    lizardfs-rgetgoal.1       # not a source
+    lizardfs-rsetgoal.1       # not a source
+    lizardfs-gettrashtime.1
+    lizardfs-settrashtime.1   # not a source
+    lizardfs-rgettrashtime.1  # not a source
+    lizardfs-rsettrashtime.1  # not a source
+    lizardfs-makesnapshot.1
     mfsmount.1
-    mfsrepquota.1
-    mfssetquota.1       # not a source
-    mfstools.1
+    lizardfs-repquota.1
+    lizardfs-setquota.1       # not a source
+    lizardfs.1
     globaliolimits.cfg.5
     iolimits.cfg.5
     mfschunkserver.cfg.5

=== src/chunkserver/CMakeLists.txt ===
include_directories(${CMAKE_CURRENT_SOURCE_DIR})
add_definitions(-DLIZARDFS_MAX_FILES=10000)
add_definitions(-DAPPNAME=mfschunkserver)

collect_sources(CHUNKSERVER)
add_library(chunkserver ${CHUNKSERVER_SOURCES})
target_link_libraries(chunkserver lzfsprotocol mfscommon ${ADDITIONAL_LIBS})
add_tests(chunkserver ${CHUNKSERVER_TESTS})

add_executable(mfschunkserver ${MAIN_SRC})
target_link_libraries(mfschunkserver chunkserver ${PAM_LIBRARIES})

if(SYSTEMD_FOUND)
  target_link_libraries(mfschunkserver ${SYSTEMD_LIBRARIES})
endif()

install(TARGETS mfschunkserver RUNTIME DESTINATION ${SBIN_SUBDIR})

=== src/common/CMakeLists.txt ===
--- 
+++ 
@@ -6,6 +6,7 @@
 list(REMOVE_ITEM COMMON_SOURCES "${CMAKE_CURRENT_SOURCE_DIR}/lockfile.cc")
 list(REMOVE_ITEM COMMON_SOURCES "${CMAKE_CURRENT_SOURCE_DIR}/metadata.cc")
 list(REMOVE_ITEM COMMON_SOURCES "${CMAKE_CURRENT_SOURCE_DIR}/setup.cc")
+list(REMOVE_ITEM COMMON_SOURCES "${CMAKE_CURRENT_SOURCE_DIR}/loop_watchdog.cc")
 endif()
 
 if(ISAL_LIBRARY)

=== src/master/CMakeLists.txt ===
include_directories(${CMAKE_CURRENT_SOURCE_DIR})
add_definitions(-DAPPNAME=mfsmaster)

collect_sources(MASTER)

if(NOT DB_FOUND)
  list(REMOVE_ITEM MASTER_SOURCES "${CMAKE_CURRENT_SOURCE_DIR}/hstring_bdbstorage.cc")
endif()

add_library(master ${MASTER_SOURCES})
target_link_libraries(master mfscommon ${ADDITIONAL_LIBS})
if(JUDY_LIBRARY)
  target_link_libraries(master ${JUDY_LIBRARY})
endif()
if(DB_FOUND)
  target_link_libraries(master ${DB_LIBRARY})
endif()
add_tests(master ${MASTER_TESTS})

add_executable(mfsmaster ${MAIN_SRC})
target_link_libraries(mfsmaster master ${PAM_LIBRARIES})
if(SYSTEMD_FOUND)
  target_link_libraries(mfsmaster ${SYSTEMD_LIBRARIES})
endif()
install(TARGETS mfsmaster RUNTIME DESTINATION ${SBIN_SUBDIR})

configure_file(mfsrestoremaster.in mfsrestoremaster @ONLY)
install(PROGRAMS ${CMAKE_CURRENT_BINARY_DIR}/mfsrestoremaster DESTINATION ${SBIN_SUBDIR})

=== src/metalogger/CMakeLists.txt ===
include_directories(${CMAKE_CURRENT_SOURCE_DIR})
add_definitions(-DMETALOGGER)
add_definitions(-DAPPNAME=mfsmetalogger)

collect_sources(METALOGGER)

add_library(metalogger ${METALOGGER_SOURCES} ../master/changelog.cc ../master/masterconn.cc)
target_link_libraries(metalogger mfscommon)
add_tests(metalogger ${METALOGGER_TESTS})

add_executable(mfsmetalogger ${MAIN_SRC})
target_link_libraries(mfsmetalogger metalogger ${PAM_LIBRARIES})
if(SYSTEMD_FOUND)
  target_link_libraries(mfsmetalogger ${SYSTEMD_LIBRARIES})
endif()
install(TARGETS mfsmetalogger RUNTIME DESTINATION ${SBIN_SUBDIR})

=== src/metarestore/CMakeLists.txt ===
--- 
+++ 
@@ -13,7 +13,9 @@
 endif()
 
 add_library(metarestore ${METARESTORE_SOURCES} ${METARESTORE_MASTER_SOURCES} ${METARESTORE_HSTRING_SOURCES}
-  ../master/chunks.cc ../master/quota_database.cc ../master/chunk_goal_counters.cc ../master/restore.cc ../master/locks.cc)
+  ../master/chunks.cc ../master/quota_database.cc ../master/chunk_goal_counters.cc ../master/restore.cc
+  ../master/locks.cc ../master/task_manager.cc ../master/snapshot_task.cc ../master/setgoal_task.cc
+  ../master/settrashtime_task.cc)
 
 target_link_libraries(metarestore mfscommon)
 if(JUDY_LIBRARY)

=== src/protocol/CMakeLists.txt ===
include_directories(${CMAKE_CURRENT_SOURCE_DIR})

collect_sources(PROTOCOL)

add_library(lzfsprotocol ${PROTOCOL_SOURCES})

# if (ZLIB_FOUND)
#   target_link_libraries(mfscommon ${ZLIB_LIBRARIES})
# endif()
# if (RT_LIBRARY)
#   target_link_libraries(mfscommon ${RT_LIBRARY})
# endif()
# if(TCMALLOC_LIBRARY)
#   target_link_libraries(mfscommon ${TCMALLOC_LIBRARY})
# endif()
# if(SOCKET_FOUND)
#   target_link_libraries(mfscommon ${SOCKET_LIBRARIES})
# endif()
add_tests(lzfsprotocol ${PROTOCOL_TESTS})

=== debian/changelog ===
lizardfs (3.10.4+dfsg-2~bpo8+1) jessie-backports; urgency=medium

  * Rebuild for jessie-backports.

 -- Dmitry Smirnov <onlyjob@debian.org>  Thu, 27 Oct 2016 11:39:09 +1100

lizardfs (3.10.4+dfsg-2) unstable; urgency=medium

  * New upstream patch to fix FTBFS on [armel].

 -- Dmitry Smirnov <onlyjob@debian.org>  Fri, 21 Oct 2016 09:14:12 +1100

lizardfs (3.10.4+dfsg-1) unstable; urgency=low

  * New upstream release [October 2016].
  * Depends += "lsb-base"; (init.d-script-needs-depends-on-lsb-base).

 -- Dmitry Smirnov <onlyjob@debian.org>  Thu, 20 Oct 2016 08:44:30 +1100

lizardfs (3.10.2+dfsg-1) unstable; urgency=medium

  * New upstream release [September 2016].
  * Build-Depends:
    + bash-completion
    + libdb-dev
    - libboost-all-dev [amd64]
    + libboost-all-dev
  * client: Recommends += "fuse".
  * rules:
    + build with "ENABLE_TESTS=YES" on all architectures.
    + prevent xsltproc network access.
  * install bash-completion for "lizardfs(1)".

 -- Dmitry Smirnov <onlyjob@debian.org>  Thu, 15 Sep 2016 02:02:38 +1000

lizardfs (3.9.4+dfsg-5~bpo8+1) jessie-backports; urgency=medium

  * Rebuild for jessie-backports.

 -- Dmitry Smirnov <onlyjob@debian.org>  Fri, 25 Mar 2016 08:52:24 +1100

lizardfs (3.9.4+dfsg-4~bpo8+1) jessie-backports; urgency=medium

  * Rebuild for jessie-backports.

 -- Dmitry Smirnov <onlyjob@debian.org>  Mon, 22 Feb 2016 12:31:31 +1100

lizardfs (3.9.4+dfsg-3~bpo8+1) jessie-backports; urgency=medium

  * Rebuild for jessie-backports.

 -- Dmitry Smirnov <onlyjob@debian.org>  Mon, 01 Feb 2016 20:46:22 +1100

lizardfs (2.6.0+dfsg-1~bpo8+1) jessie-backports; urgency=low

  * Rebuild for jessie-backports.

 -- Dmitry Smirnov <onlyjob@debian.org>  Fri, 17 Jul 2015 11:41:18 +1000

=== debian/control ===
--- 
+++ 
@@ -2,7 +2,7 @@
 Section: admin
 Priority: optional
 Maintainer: Dmitry Smirnov <onlyjob@debian.org>
-Build-Depends: debhelper (>= 9.20160403~), dh-python, dh-systemd
+Build-Depends: debhelper (>= 9.20160403~), dh-python, dh-systemd, bash-completion
               ,python-all
               ,cmake
               ,asciidoc
@@ -14,6 +14,7 @@
 # libcrcutil is for little-endian architectures only.
               ,libcrcutil-dev [!hppa !m68k !mips !powerpc !powerpcspe !ppc64 !s390 !s390x !sparc !sparc64]
               ,libfuse-dev (>= 2.9.0)
+              ,libdb-dev
 #_beware:     ,libgoogle-perftools-dev
               ,libgtest-dev
               ,libisal-dev [amd64 kfreebsd-amd64]
@@ -23,7 +24,7 @@
 #             ,libthrift-dev
               ,zlib1g-dev
 # -DENABLE_TESTS=YES requirements:
-             ,libboost-all-dev [amd64]
+             ,libboost-all-dev
 Standards-Version: 3.9.8
 X-Python-Version: >= 2.7 << 3.0
 Homepage: http://lizardfs.org/
@@ -58,7 +59,7 @@
 Package: lizardfs-master
 Built-Using: ${my:Built-Using}
 Architecture: any
-Depends: ${shlibs:Depends}, ${misc:Depends}
+Depends: ${shlibs:Depends}, ${misc:Depends}, lsb-base
         ,lizardfs-common (>= ${source:Version})
 Description: LizardFS - master server
  LizardFS master (metadata) server.
@@ -83,7 +84,7 @@
 Package: lizardfs-metalogger
 Built-Using: ${my:Built-Using}
 Architecture: any
-Depends: ${shlibs:Depends}, ${misc:Depends}
+Depends: ${shlibs:Depends}, ${misc:Depends}, lsb-base
         ,lizardfs-common (>= ${source:Version})
 Description: LizardFS - metalogger server
  LizardFS metadata replication (backup) server.
@@ -108,7 +109,7 @@
 Package: lizardfs-chunkserver
 Built-Using: ${my:Built-Using}
 Architecture: any
-Depends: ${shlibs:Depends}, ${misc:Depends}
+Depends: ${shlibs:Depends}, ${misc:Depends}, lsb-base
         ,lizardfs-common (>= ${source:Version})
 Description: LizardFS - data server
  The LizardFS data server.
@@ -134,6 +135,7 @@
 Built-Using: ${my:Built-Using}
 Architecture: any
 Depends: ${shlibs:Depends}, ${misc:Depends}
+Recommends: fuse
 Description: LizardFS - client tools and mount utility
  LizardFS FUSE mount utility "mfsmount" and client tool "mfstools".
  .

=== debian/rules ===
--- 
+++ 
@@ -14,13 +14,10 @@
 # minimise needless linking
 export DEB_LDFLAGS_MAINT_APPEND += -Wl,--as-needed
 
-## Build tests only on amd64, see https://github.com/lizardfs/lizardfs/issues/197
-ifeq ($(DEB_HOST_ARCH),amd64)
-OPTARGS = -DENABLE_TESTS=YES
-endif
+export XSLTPROCFLAGS=--nonet
 
 %:
-	dh $@ --buildsystem=cmake --builddirectory=build --parallel --with systemd,python2
+	dh $@ --buildsystem=cmake --builddirectory=build --parallel --with systemd,python2,bash-completion
 
 override_dh_auto_clean:
 	$(RM) -rv external/gtest
@@ -29,14 +26,15 @@
 override_dh_auto_configure:
 	## copy gtest sources
 	cp -Rv /usr/src/gtest external/
-	dh_auto_configure -- $(OPTARGS)    \
+	dh_auto_configure --               \
                -DCMAKE_BUILD_TYPE=Release   \
                -DCMAKE_INSTALL_PREFIX="/"   \
                -DCMAKE_VERBOSE_MAKEFILE=ON  \
                -DENABLE_VERBOSE_ASCIIDOC=ON \
                -DENABLE_DEBIAN_PATHS=YES    \
                -DENABLE_TCMALLOC=NO         \
-               -DENABLE_UTILS=YES
+               -DENABLE_UTILS=YES           \
+               -DENABLE_TESTS=YES
 
 override_dh_auto_install:
 	dh_auto_install
